#ifndef _libcomp
#define _libcomp


#define MAXFLOPSPERELEMENT    1000000  // flop = multi
#define MAXMEMPERELEMENT      1000000  //




inline void DoFlops(const unsigned flopsperelement);
inline void DoReads(const unsigned readsperelement);
inline void DoWrites(const unsigned readsperelement);



void RunIter(const unsigned numelements,
	     const unsigned flops,
	     const unsigned reads,
	     const unsigned writes);


#include <sys/time.h>
#include <iostream>

struct Time : public timeval
{
  Time(const Time &rhs);
  Time(const timeval &rhs);
  Time(const double time);
  Time(const unsigned sec, const unsigned usec);
  Time(); // gets the current time

  Time & operator=(const Time &rhs);
  Time & operator=(const double &rhs);

  void SetToCurrentTime();

  operator double() const;

  bool operator<(const Time &rhs) const;
  bool operator>(const Time &rhs) const;
  bool operator==(const Time &rhs) const;

  ostream & Print(ostream &os) const;
};

inline ostream & operator<<(ostream &os, const Time &  obj) {
  return obj.Print(os);
}


template <class T> T MIN(T lhs, T rhs) { return (lhs<rhs) ? lhs : rhs;}
template <class T> T MAX(T lhs, T rhs) { return (lhs>rhs) ? lhs : rhs;}



#endif
