#!/usr/bin/perl -w

$#ARGV==0 or die "usage:parse_pvmout.pl file";

open(FILE,$ARGV[0]);
@lines=<FILE>;
close(FILE);
chomp(@lines);

@runs = split("pvm car model",join(" ", @lines));
shift @runs;


print "numcars\tnumiters\tflopspercar\treadspercar\twritespercar\tnumprocs\twallclock\tuser\tsystem\tuci\tsci\tips\tmcs\tmfs\n";

foreach $run (@runs) { 
  if ($run =~ /.*numcars\s+=\s+(\d+)\s+numiters\s+=\s+(\d+)\s+flopspercar\s+=\s+(\d+)\s+readspercar\s+=\s+(\d+)\s+writespercar\s+=\s+(\d+)\s+numprocs\s+=\s+(\d+)/) {
    $numcars=$1;
    $numiters=$2;
    $flopspercar=$3;
    $readspercar=$4;
    $writespercar=$5;
    $numprocs=$6;
  } else {
    print STDERR "Parse failure for run header.\n";
  }

  if ($run =~ /.*Process 0:\s+Wallclock\s+=\s+(\S+)\s+seconds\s+User\s+=\s+(\S+)\s+seconds\s+System\s+=\s+(\S+)\s+seconds\s+Usertime\/car\/iter\s+=\s+(\S+)\s+microseconds\s+Systime\/car\/iter\s+=\s+(\S+)\s+microseconds\s+Iters\/s\s+=\s+(\S+)\s+MCars\/s\s+=\s+(\S+)\s+MFLOP\/s\s+=\s+(\S+)\s+/) {
    $wallclock=$1;
    $user = $2;
    $system = $3;
    $uci = $4;
    $sci = $5;
    $ips = $6;
    $mcs = $7;
    $mfs = $8;
  } else {
    print STDERR "Parse failure for process 0.\n";
  }
  
  print "$numcars\t$numiters\t$flopspercar\t$readspercar\t$writespercar\t$numprocs\t$wallclock\t$user\t$system\t$uci\t$sci\t$ips\t$mcs\t$mfs\n";
}
